Bug 654746 - add gnome3 support, make default browser work again for xdg-settings
add gnome3 support, make default browser work again for xdg-settings
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: xdg-utils (Show other bugs)
rawhide
Unspecified Unspecified
low Severity medium
: ---
: ---
Assigned To: Rex Dieter
Fedora Extras Quality Assurance
: Patch
Depends On:
Blocks: F15Blocker/F15FinalBlocker
  Show dependency treegraph
 
Reported: 2010-11-18 13:13 EST by Bastien Nocera
Modified: 2018-04-11 10:20 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-01 10:25:59 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch (5.27 KB, patch)
2010-11-18 13:13 EST, Bastien Nocera
no flags Details | Diff
updated patch (5.27 KB, patch)
2010-11-18 21:32 EST, Bastien Nocera
no flags Details | Diff
new patch (8.17 KB, patch)
2010-11-18 22:31 EST, Bastien Nocera
no flags Details | Diff

  None (edit)
Description Bastien Nocera 2010-11-18 13:13:46 EST
Created attachment 461347 [details]
patch

GNOME switched to using the x-scheme-handler/http(s) for the default browser, instead of a custom GConf setting.

See also:
http://www.hadess.net/2010/10/new-control-center-and-you.html
http://standards.freedesktop.org/shared-mime-info-spec/shared-mime-info-spec-latest.html#id2869854
Comment 1 Bastien Nocera 2010-11-18 13:16:22 EST
Note that this is needed for Chromium to detect whether it's the default browser or not.
Comment 2 Colin Walters 2010-11-18 13:21:06 EST
In order to upstream this patch, wouldn't we need to make it able to detect GNOME 2.32 vs 3 and choose the right one?
Comment 3 Rex Dieter 2010-11-18 13:29:45 EST
Any sh snippet advice on how to detect gnome3?  (and is this change specific to gnome3)?
Comment 4 Bastien Nocera 2010-11-18 14:31:32 EST
(In reply to comment #3)
> Any sh snippet advice on how to detect gnome3?  (and is this change specific to
> gnome3)?

It's GNOME3 specific, so this is what we'll need in Fedora going forward (from F15 onwards).
Comment 5 Bastien Nocera 2010-11-18 21:32:37 EST
Created attachment 461430 [details]
updated patch

Fixes xdg-settings check not working as expected (we were comparing a desktop name to a binary one).
Comment 6 Bastien Nocera 2010-11-18 21:35:43 EST
(In reply to comment #2)
> In order to upstream this patch, wouldn't we need to make it able to detect
> GNOME 2.32 vs 3 and choose the right one?

Right, it seems that the upstream isn't as dead as I thought and Rex is a committer, so I should fix it up.
Comment 7 Bastien Nocera 2010-11-18 22:31:02 EST
Created attachment 461442 [details]
new patch

Adds the ability to detect GNOME 3.x, on its own, and also ports the mailto functionality to x-scheme-handler.

I also tested the GNOME3 code path more thoroughly for the browser settings, and it works as expected on the command-line, and when used in chromium ("check" to detect the current browser, and "set" to set chromium as the default browser).
Comment 8 Bastien Nocera 2011-02-01 07:58:40 EST
Any news on this?
Comment 9 Rex Dieter 2011-02-01 08:27:43 EST
Thanks for the poke, I'll work on this today.
Comment 10 Rex Dieter 2011-02-01 10:25:59 EST
Patch upstreamed (with some minor fuzz),

http://cgit.freedesktop.org/xdg/xdg-utils/commit/?id=6f49c05ceb2a1935d07c49c2e100b5cf3cdf5f26

and snapshot build xdg-utils-1.1.0-0.2.20110201.fc15 submitted,
http://koji.fedoraproject.org/koji/taskinfo?taskID=2754753
Comment 11 Mark Rosenstand 2011-07-13 20:26:23 EDT
Not sure if this needs to be re-opened or if it's a new issue, but the functionality is broken in xdg-utils-1.1.0-0.6.20110505.fc15.noarch.

[mark@thinkpad ~]$ xdg-settings get default-web-browserwhich: no gnome-default-applications-properties in (/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin:/home/mark/bin)
which: no gnome-default-applications-properties in (/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin:/home/mark/bin)
google-chrome.desktop
[mark@thinkpad ~]$ /opt/google/chrome/xdg-settings get default-web-browser
which: no gnome-default-applications-properties in (/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin:/home/mark/bin)
google-chrome.desktop

Chrome will use the system supplied one if available, and it keeps asking me if it can be the default. I've tried both stable (Chrome 12) and unstable (Chrome 14) and both fail.

As an aside, why is which(1) stderr output redirected to stdout?
Comment 12 Mark Rosenstand 2011-07-13 20:34:32 EDT
I think the Chromium guys figured it out. Please pick up the change from here: http://code.google.com/p/chromium/issues/detail?id=89258#c4
Comment 13 Mark Rosenstand 2011-07-13 20:45:58 EDT
Filed a separate bug: https://bugzilla.redhat.com/show_bug.cgi?id=721188

Note You need to log in before you can comment on or make changes to this bug.